#include "bench.h"

int test_builtin_ffs(int rc)
{
	int c;

	for (c=0; c<512; c++) {
		rc += ffs(rc);
		rc += ffs(rc+1);
		rc += ffs(rc+2);
		rc += ffs(rc+3);
		rc += ffs(rc+4);
		rc += ffs(rc+5);
		rc += ffs(rc+6);
		rc += ffs(rc+7);
		rc += ffs(rc << 8);
		rc += ffs(rc << 10);
		rc += ffs(rc << 12);
		rc += ffs(rc << 14);
		rc += ffs(rc << 16);
		rc += ffs(rc << 8);
		rc += ffs(rc << 10);
		rc += ffs(rc << 12);
		rc += ffs(rc << 14);
		rc += ffs(rc << 16);
		rc += ffs(rc << 8);
		rc += ffs(rc << 10);
		rc += ffs(rc << 12);
		rc += ffs(rc << 14);
		rc += ffs(rc << 16);
		rc += ffs(rc);
		rc += ffs(rc+1);
		rc += ffs(rc+2);
		rc += ffs(rc+3);
		rc += ffs(rc+4);
		rc += ffs(rc+5);
		rc += ffs(rc+6);
		rc += ffs(rc+7);
	}
	return rc;
}

char buffer[1024 * 128];

void test_builtin_index(int c) {
	index(buffer+c*128, 'X');
	index(buffer+c*128, 'Y');
	rindex(buffer+c*128, 'X');
}

void test_builtin_bzero_bcmp(int c) {
	static b1[1024 * 128];
	static b2[1024 * 128];

	bzero(b1, c*128);
	bzero(b2, c*128);
	bcmp(b1, b2, c*128);
}

void test_builtin()
{
	int c;

	for (c=0; c<1024*128; c++)
		buffer[c]='a'+c%26;
	buffer[c/2]='X';
	buffer[c-2]='Y';
	buffer[c-1]=0;

	timer_start(CONTEXT_LOCAL);
	for (c=0; c<1024; c++) {
		result_push(CONTEXT_LOCAL, test_builtin_ffs(c) );
		test_builtin_index(c);
		test_builtin_bzero_bcmp(c);
	}
	timer_stop(CONTEXT_LOCAL);
}

